﻿'A reference to the Phidget22.NET.dll must be added to new projects in VB.Net 
'From the "Project" menu select "Add Reference" 
'From the "Add Reference" window select the "Browse" tab 
'Browse to the directory you installed the Phidgets library to 
'The default is "C:\Program Files\Phidgets" 
'Select "Phidget22.NET.dll" and click "OK" 
'To view objects that have been added, select the "View" menu 
'Select "Object Browser" 
'Then expand the Phidget22.NET.dll item 



Imports Phidget22
Imports Phidget22.Events
Imports System.Text

Public Class Form1
    Dim WithEvents device As Phidget22.IR
    Dim open As ExampleUtils.ExampleUtils.CommandLineOpen
    Dim errorBox As ErrorEventBox
    Dim repeatCount As Integer = 0
    Dim buttonPressed As Boolean = False

    Dim lastLearnedCode As String = Nothing
    Dim lastLearnedCodeInfo As IRCodeInfo = Nothing

    Dim rawDataCol As Integer = 0

    Public Sub New()
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        ' This call is required by the Windows Form Designer.
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
        ' Add any initialization after the InitializeComponent() call.
    End Sub

    Public Sub New(ByVal commandLine As String())
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        open.commandLine = commandLine
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        errorBox = New ErrorEventBox(Me)
        device = New Phidget22.IR()

        Dim phidgetParameters As ExampleUtils.commandLineData = open.parseCmdLine()

        Try 'set all the values grabbed from command line.  these values have defaults that are set in ExampleUtils.vb, you can check there to see them
            device.Channel = phidgetParameters.Channel 'selects the channel on the device to open
            device.DeviceSerialNumber = phidgetParameters.SerialNumber 'selects the device or hub to open
            device.HubPort = phidgetParameters.HubPort 'selects th eport on the hub to open
            device.IsHubPortDevice = phidgetParameters.isHubPortDevice 'is the device a port on a vint hub?

            If phidgetParameters.isRemote Then 'are we trying to open a remote device?
                device.IsRemote = True
                Net.EnableServerDiscovery(ServerType.Device) 'turn on network scan
                If phidgetParameters.Password <> vbNullString And phidgetParameters.ServerName <> vbNullString Then
                    Net.SetServerPassword(phidgetParameters.ServerName, phidgetParameters.Password)
                End If
            Else
                device.IsLocal = True
            End If

            device.Open() 'open the device specified by the above parameters
        Catch ex As PhidgetException
            errorBox.addMessage("Error opening the device: " + ex.Message)
        End Try
    End Sub

    'when the application is being terminated, close the phidget
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles Me.FormClosing
        If device.Attached Then
            device.Close()
        End If
    End Sub

    Delegate Sub bufferDelegate(ByVal data As Integer(), ByVal length As Integer)
    Dim rawDataRecieveBuffer As List(Of Integer) = New List(Of Integer)()

    Public Sub printRawData(ByVal data As Integer(), ByVal length As Integer)
        If (rawDataBox.InvokeRequired) Then
            Try
                rawDataBox.Invoke(New bufferDelegate(AddressOf printRawData), New Object() {data, length})
            Catch ex As Exception

            End Try
        Else
            If (rawDataCheckBox.Checked) Then
                SyncLock (rawDataRecieveBuffer)
                    For i As Integer = 0 To (length - 1)
                        If (data(i) = Phidget22.IR.RawDataLongSpace) Then
                            rawDataBox.AppendText(Environment.NewLine + Environment.NewLine)
                            rawDataBox.AppendText("LONG")
                            rawDataBox.AppendText(Environment.NewLine)
                            rawDataBox.ScrollToCaret()
                            rawDataCol = -1

                            rawDataRecieveBuffer.Clear()
                        ElseIf (data(i) > 100000) Then
                            rawDataBox.AppendText(Environment.NewLine + Environment.NewLine)
                            rawDataBox.AppendText(data(i).ToString().PadLeft(7) + ",")
                            rawDataBox.AppendText(Environment.NewLine)
                            rawDataBox.ScrollToCaret()
                            rawDataCol = -1

                            rawDataRecieveBuffer.Add(data(i))
                        Else
                            rawDataBox.AppendText(data(i).ToString().PadLeft(7) + ",")

                            rawDataRecieveBuffer.Add(data(i))
                        End If
                        rawDataCol += 1
                        If (rawDataCol >= 10) Then
                            rawDataBox.AppendText(Environment.NewLine)
                            rawDataBox.ScrollToCaret()
                            rawDataCol = 0
                        End If
                    Next

                    If (rawDataRecieveBuffer.Count > 0) Then
                        sendRawDataBtn.Enabled = True
                    Else
                        sendRawDataBtn.Enabled = False
                    End If
                End SyncLock
            End If
        End If
    End Sub

    Sub ir_RawData(ByVal sender As Object, ByVal e As IRRawDataEventArgs) Handles device.RawData
        If (eventRawDataRadio.Checked) Then
            printRawData(e.Data, e.Data.Length)
        End If
    End Sub

    Sub ir_Learn(ByVal sender As Object, ByVal e As IRLearnEventArgs) Handles device.Learn
        codeLearnTextBox.Text = "0x" + e.Code.ToString()

        bitLengthLearnTextBox.Text = e.CodeInfo.BitCount.ToString()
        lengthLearnTextBox.Text = ExampleUtils.GetDescription(e.CodeInfo.Length) + " Length"
        encodingTextBox.Text = ExampleUtils.GetDescription(e.CodeInfo.Encoding)
        gapTextBox.Text = e.CodeInfo.Gap.ToString()

        If (e.CodeInfo.Trail <> 0) Then
            trailTextBox.Text = e.CodeInfo.Trail.ToString()
        Else
            trailTextBox.Text = "None"
        End If

        oneTextBox.Text = e.CodeInfo.One(0).ToString() + ", " + e.CodeInfo.One(1).ToString()
        zeroTextBox.Text = e.CodeInfo.Zero(0).ToString() + ", " + e.CodeInfo.Zero(1).ToString()

        If (e.CodeInfo.Header IsNot Nothing) Then
            Dim sb As StringBuilder = New StringBuilder(e.CodeInfo.Repeat.Length * 2)
            For Each i As Integer In e.CodeInfo.Repeat
                sb.Append(i.ToString())
                sb.Append(", ")
            Next
            repeatTextBox.Text = sb.ToString()
        Else
            repeatTextBox.Text = "No Repeat Code"
        End If
        lastLearnedCode = e.Code
        lastLearnedCodeInfo = e.CodeInfo
        retransmitButton.Enabled = True
    End Sub

    Sub ir_Code(ByVal sender As Object, ByVal e As IRCodeEventArgs) Handles device.Code
        codeTxt.Text = "0x" + e.Code.ToString()
        bitLengthTextBox.Text = e.BitCount.ToString()

        repeatCount += 1
        If (Not e.IsRepeat) Then
            repeatCount = 0
        End If

        repeatCountTextBox.Text = repeatCount.ToString()
    End Sub

    'attach event handler.. populate the details fields as well as display the attached status.  enable the checkboxes to change
    'the values of the attributes of the IR reader such as enable or disable the antenna and onboard led.
    Sub ir_Attach(ByVal sender As Object, ByVal e As AttachEventArgs) Handles device.Attach
        Dim attachedDevice As Phidget22.IR = CType(sender, Phidget22.IR)
        PhidgetInfoBox1.FillPhidgetInfo(attachedDevice)

        'clear fields
        codeTxt.Clear()
        repeatCountTextBox.Clear()
        bitLengthTextBox.Clear()
        codeBox.Visible = True
        learnBox.Visible = True
        rawDataCheckBox.Visible = True
        
    End Sub

    'detach event handler... clear all the fields, display the attached status, and disable the checkboxes
    Sub ir_Detach(ByVal sender As Object, ByVal e As DetachEventArgs) Handles device.Detach
        Dim detached As Phidget22.IR = CType(sender, Phidget22.IR)
        PhidgetInfoBox1.Clear()

        retransmitButton.Enabled = False

        codeBox.Visible = False
        learnBox.Visible = False
        rawDataCheckBox.Visible = False
    End Sub

    Sub ir_Error(ByVal sender As Object, ByVal e As ErrorEventArgs) Handles device.Error
        errorBox.addMessage(e.Description)
    End Sub

    Private Sub retransmitThread()
        System.Threading.Thread.Sleep(100)
        Try
            device.transmit(lastLearnedCode, lastLearnedCodeInfo)
            While (buttonPressed)
                device.transmitRepeat()
            End While
        Catch ex As PhidgetException
        End Try
    End Sub

    Private Sub retransmitButton_MouseDown(sender As Object, e As MouseEventArgs) Handles retransmitButton.MouseDown
        buttonPressed = True
        Dim buttonThread As System.Threading.Thread = New System.Threading.Thread(New Threading.ThreadStart(AddressOf retransmitThread))
        buttonThread.Start()
    End Sub

    Private Sub retransmitButton_MouseUp(sender As Object, e As MouseEventArgs) Handles retransmitButton.MouseUp
        buttonPressed = False
    End Sub

    Private Sub rawDataCheckBox_CheckedChanged(sender As Object, e As EventArgs) Handles rawDataCheckBox.CheckedChanged
        If (rawDataCheckBox.Checked) Then
            rawDataBox.Visible = True
            clearButton.Visible = True
            eventRawDataRadio.Visible = True
            sendRawDataBtn.Visible = True
        Else
            rawDataBox.Visible = False
            clearButton.Visible = False
            eventRawDataRadio.Visible = False
            sendRawDataBtn.Visible = False
        End If
    End Sub

    Private Sub clearButton_Click(sender As Object, e As EventArgs) Handles clearButton.Click
        rawDataBox.Clear()
        SyncLock (rawDataRecieveBuffer)
            rawDataRecieveBuffer.Clear()
        End SyncLock
        sendRawDataBtn.Enabled = False
    End Sub

    Private Sub eventRawDataRadio_CheckedChanged(sender As Object, e As EventArgs) Handles eventRawDataRadio.CheckedChanged
    End Sub

    'example of sending RAW data
    Private Sub sendRawDataBtn_Click(sender As Object, e As EventArgs) Handles sendRawDataBtn.Click
        Dim buttonTxt As String = sendRawDataBtn.Text
        Try
            ' We can send a max of 199 array items. We're going to look for 'gaps' in the captured data stream
            ' And split up the sends around these. We'll choose 50 ms as a good gap time threshold.
            ' A single button press won't have any gaps - these are seen when a button is held down.
            Dim rawChunks As List(Of rawDataChunk) = New List(Of rawDataChunk)
            SyncLock (rawDataRecieveBuffer)
                Dim chunk As rawDataChunk = New rawDataChunk()
                For Each blip As Integer In rawDataRecieveBuffer
                    If (blip >= 50000) Then
                        chunk.gap = blip
                        rawChunks.Add(chunk)
                        chunk = New rawDataChunk()
                    Else
                        chunk.dataList.Add(blip)
                    End If
                Next
                chunk.gap = 150000 'last gap, nice and big
                rawChunks.Add(chunk)
            End SyncLock

            sendRawDataBtn.Text = "Sending Data..."
            Application.DoEvents()

            For Each chunk As rawDataChunk In rawChunks
                device.TransmitRaw(chunk.data, 0, 0, chunk.gap) '0 for frequency and duty cycle will use a default value
            Next
        Catch ex As Exception
            errorBox.addMessage("Error sending raw data: " + ex.Message)
        Finally
            sendRawDataBtn.Text = buttonTxt
        End Try
    End Sub
End Class

Class rawDataChunk
    Public dataList As List(Of Integer) = New List(Of Integer)

    Public ReadOnly Property data() As Integer()
        Get
            Return dataList.ToArray()
        End Get
    End Property

    Public gap As Integer
End Class